//+------------------------------------------------------------------+
//|                                              FFS_Correlation.mq4 |
//|                                            Release date 20070205 |
//|                           Fixed by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |    
//+------------------------------------------------------------------+
#property copyright "icm63 (user name at Forex-TSD)"
#property link      "Forex-TSD"

/* 
READ ME FIRST..
I have nothing to do with www.forexforsmarties.com. 
You use these tools at YOUR OWN RISK.
I do not endorse or sell FFS methods or products in any way.
These tools are provided FREE of charge, I wish to promote the development of MT4 tools and minds
of those who trade FFS to get the best 'How to FFS tools'. So we all can trade FFS thru easy
and tough times. As the Forex market gives and takes away fortunes ! To make 5% monthly 
compounding over 10 years is not easy when the forex beast changes. 

Use with 
FFS_Trend_Basic
FFS_Correlation
FFS_CrossMA
FFS_CrossTiming
FFS_NetPipChange

IMPORTANT : Make sure the 'IndexType' is the same within each MT4 tool.
The FFS_Mode should be set as BUY, to mirror the FFS Calcutator.

This shows the correlations of the USD positive and USD Negative trends shown by
FFS_Trend. Short, medium and long term correlations are shown. This is a tool to watch
for fundamental changes in the hedge combination you are trading.

Using this tool with FFS_NetPipChange (period 2) you see that they are related, the 
FFS_NetPipChange leads the FFS_Correlation as it has a shorter time frame.

These calculations assume an equal weight between all the pairs in the 
FFS hedge combination. That each pair pip value is, at best it can be, to be
of the same value.
Example...
EURUSD pip value 100k lots is $10.00
USDCHF pip value 100k lost is $7.97 ( 1/1.2532 * 10 , as at 20070127)
so 1.25 lot must be trades to equal the EURUSD $10 pip value.

This is the index selection format
1. EUR/USD, USD/CHF
2. EUR/USD, USD/CHF, GBP/USD
3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
4. EUR/USD, USD/CHF, USD/JPY
5. EUR/USD, GBP/USD, USD/JPY
6. USD/CHF, GBP/USD
7. USD/CHF, GBP/USD, USD/JPY
8. GBP/USD, USD/JPY


*/

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Lime
#property indicator_color3 Orange
#property indicator_level1  0

//User Inputs Parameters
extern int IndexType = 3; // Inputs 1 to 8, FFS Index see above
extern int Period_Short = 5; // Inputs 3 to 18, Short term correlation study
extern int Period_Medium = 25;// Inputs 18 to 50, Medium term correlation study
extern int Period_Long = 75;// Inputs 50 to 100, Long term correlation study

//SYMBOLS for IBFX Mini change EURUSD to EURUSDm
string sEURUSD = "EURUSD";
string sGBPUSD = "GBPUSD";
string sUSDCHF = "USDCHF";
string sUSDJPY = "USDJPY";


//---- variables
double USDcorrS[];
double USDcorrM[];
double USDcorrL[];
double USDpos[];
double USDneg[];
double normUSDpos[];
double normUSDneg[];


int init()
{
   IndicatorShortName("FFS_Correlation, Above Poor, Below Good. Index " + IndexType +", ");
   
   IndicatorBuffers(7);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,Period_Long);
   SetIndexBuffer(0,USDcorrS);
   SetIndexLabel(0,"Corr_Short");
   SetIndexDrawBegin(0,5);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,Period_Long);
   SetIndexBuffer(1,USDcorrM);
   SetIndexLabel(1,"Corr_Medium");
   SetIndexDrawBegin(1,5);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexDrawBegin(2,Period_Long);
   SetIndexBuffer(2,USDcorrL);
   SetIndexLabel(2,"Corr_Long");
   SetIndexDrawBegin(2,5);
   
   SetIndexBuffer(3,USDpos);
   SetIndexBuffer(4,USDneg);
   SetIndexBuffer(5,normUSDpos);
   SetIndexBuffer(6,normUSDneg);


   return(0);
}
//------------------------------------
int deinit()
{   
   return(0);
}
int start()
{      
   int limit;
   //int counted_bars=IndicatorCounted();
   //if(counted_bars<0) return(-1);
   //if (counted_bars>0)counted_bars--;
   //else counted_bars = 1;
   //limit=Bars-counted_bars;
   limit=Bars-1;
   double EURW, GBPW, CHFW, JPYW;

   //Determine correct weight to get all prices on scale of 10,000
   EURW = 10000/DivZERO(sEURUSD);
   GBPW = 10000/DivZERO(sGBPUSD);
   CHFW = 10000/DivZERO(sUSDCHF);
   JPYW = 10000/DivZERO(sUSDJPY);
   //Print("EURW :" + EURW + "  Price : " +iClose("EURUSD",0,1));
      
   for(int i=limit; i>=0; i--)
            {
            switch(IndexType)
               {
               case 1:
                     //1. EUR/USD, USD/CHF"
                     USDpos[i]=  iClose(sEURUSD,0,i) * EURW;
                     USDneg[i]=  iClose(sUSDCHF,0,i) * CHFW;
                     break;
               case 2:
                     //2. EUR/USD, USD/CHF, GBP/USD
                     USDpos[i]=  iClose(sEURUSD,0,i) * EURW + iClose(sGBPUSD,0,i)  * GBPW ;
                     USDneg[i]=  iClose(sUSDCHF,0,i) * CHFW;
                     break;
               case 3:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose(sEURUSD,0,i) * EURW + iClose(sGBPUSD,0,i)  * GBPW ;
                     USDneg[i]=  iClose(sUSDCHF,0,i) * CHFW + iClose(sUSDJPY,0,i)  * JPYW ;
                     break;
               case 4:
                     //4. EUR/USD, USD/CHF, USD/JPY
                     USDpos[i]=  iClose(sEURUSD,0,i) * EURW;
                     USDneg[i]=  iClose(sUSDCHF,0,i) * CHFW + iClose(sUSDJPY,0,i)  * JPYW ;
                     break;
               case 5:
                     //5. EUR/USD, GBP/USD, USD/JPY
                     USDpos[i]=   iClose(sEURUSD,0,i) * EURW + iClose(sGBPUSD,0,i)  * GBPW ;
                     USDneg[i]=   iClose(sUSDJPY,0,i)  * JPYW  ;
                     break;
               case 6:
                     //6. USD/CHF, GBP/USD
                     USDpos[i]=  iClose(sGBPUSD,0,i) * GBPW ;
                     USDneg[i]=  iClose(sUSDCHF,0,i) * CHFW ;
                     break;
               case 7:
                     //7. USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose(sGBPUSD,0,i) * GBPW ;
                     USDneg[i]=  iClose(sUSDCHF,0,i) * CHFW + iClose(sUSDJPY,0,i)  * JPYW  ;
                     break;  
               case 8:
                     //8. GBP/USD, USD/JPY 
                     USDpos[i]=  iClose(sGBPUSD,0,i) * GBPW ;
                     USDneg[i]=  iClose(sUSDJPY,0,i)  * JPYW  ;
                     break;
               default:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose(sEURUSD,0,i) * EURW + iClose(sGBPUSD,0,i)  * GBPW ;
                     USDneg[i]=  iClose(sUSDCHF,0,i) * CHFW + iClose(sUSDJPY,0,i)  * JPYW ;
                     break;
              }
              
               double MaxPos=-10000000, MinPos=10000000;
               double MaxNeg=-10000000, MinNeg=10000000;
       
              for ( int k=0; k<=limit-1;k++)
              {
                 if( USDpos[i+k] > MaxPos) MaxPos = USDpos[i+k];
                 if( USDpos[i+k] < MinPos) MinPos = USDpos[i+k];
                 if( USDneg[i+k] > MaxNeg) MaxNeg = USDneg[i+k];
                 if( USDneg[i+k] < MinNeg) MinNeg = USDneg[i+k];
              }
   }
       
   //Normalise Data btw 0 and 100
   for(int m=limit; m>=0; m--)
   {
     if (MaxPos - MinPos != 0) normUSDpos[m] = 100*(USDpos[m]-MinPos)/(MaxPos-MinPos);  
     if (MaxNeg - MinNeg != 0) normUSDneg[m] = (100*(USDneg[m]-MinNeg)/(MaxNeg-MinNeg)); 
   }
   CorrelationFx(USDcorrS,normUSDpos, normUSDneg,Period_Short,limit);
   CorrelationFx(USDcorrM,normUSDpos, normUSDneg,Period_Medium,limit);
   CorrelationFx(USDcorrL,normUSDpos, normUSDneg,Period_Long,limit);
   return(0);
}

//FUNCTIONS
void CorrelationFx(
double& OutArray[], 
double& normUSDpos[],
double& normUSDneg[], 
double cPeriod, 
double nlimit)
{
   for(int i= nlimit; i>=0; i--)
   {       
   double SumXY  = 0;
   double SumX   = 0;
   double SumX2  = 0;
   double SumY   = 0;
   double SumY2  = 0;
   
   for(int k=0;k<=cPeriod-1;k++) 
   {
   SumXY += normUSDpos[i+k]*normUSDneg[i+k];
   SumX  += normUSDpos[i+k];
   SumY  += normUSDneg[i+k];
   SumX2 += normUSDpos[i+k]*normUSDpos[i+k];
   SumY2 += normUSDneg[i+k]*normUSDneg[i+k];
   }
   
   if((SumX2-SumX*SumX/cPeriod)*(SumY2-SumY*SumY/cPeriod)!=0) 
   OutArray[i] = (SumXY - SumX*SumY/cPeriod)/MathPow((SumX2-SumX*SumX/cPeriod)*(SumY2-SumY*SumY/cPeriod),0.5);        
   }
}
//+------------------------------------------------------------------+

//Divide by ZERO fix
double DivZERO(string Sym)
{
double res;
if(iClose(Sym,0,0) != 0)
  res = iClose(Sym,0,0);
else
  res = iClose(Sym,TIME_DATE,1);
      
return(res);      
}